﻿#If NoCompile Then
Ein korrekter Uri zu im Projekt eingebundenen Dateien hat eine längliche und aufwändige Syntax, zB "pack://application:,,,/FolderBrowser;component/Images/DRIVE.ICO"
Hierbei gibt "pack://application:,,," an, dass auf Anwendungs-Resourcen zugegriffen wird. "/FolderBrowser;component/" gibt die Assembly an und "/Images/DRIVE.ICO" schließlich ist Pfad und Datei relativ zum Projekt-Ordner.
Da üblicherweise Bild-Dateien alle im selben Ordner liegen, kann man den gesamten vorderen Teil einmal merken, und kann dann aus vielen kurzen Dateinamen immer einen gültigen Uri bilden.
ImageList liest die Dateien (oder sinds Resourcen?) dann gleich in ein BitmapImage - wobei Fehler im Designmode noch ins Ausgabefenster gemeldet werden, inne Release ignoriert.
Weil Lesefehler sollen nicht gleich den Xaml-Designer unbrauchbar werden lassen.
zB
Private Shared _Images As New ImageList("pack://application:,,,/FolderBrowser;component/Images", "DRIVE.ICO", "OpenFolder.ICO", "CLSDFOLD.ICO")
ist eine ImageList mit 3 Bildern, 
#End If
Namespace System.Windows.Media.Imaging

   Public Class ImageList : Inherits List(Of BitmapImage)
      Private Shared _ErrorImage As BitmapImage
      Public Shared ReadOnly Property ErrorImage As BitmapImage
         Get
            If _ErrorImage.Null Then
               Dim thisAssembly = Reflection.Assembly.GetExecutingAssembly.FullName.LeftCut(",")
               _ErrorImage = New BitmapImage(New Uri("pack://application:,,,/".And(thisAssembly, ";component/Icons/Error.ico")))
            End If
            Return _ErrorImage
         End Get
      End Property
      Public Sub New(commonUriPart As String, ParamArray files As String())
         If Not commonUriPart.EndsWith("/") Then commonUriPart += "/"c
         For Each s In files
            Try
               MyBase.Add(New BitmapImage(New Uri(commonUriPart & s.Trim())))
            Catch ex As Exception
               Debug.Print("Error in class: ""{0}""{1}{2}: {3}", Me.GetType.AssemblyQualifiedName, Environment.NewLine, ex.GetType.Name, ex.Message)
               MyBase.Add(ErrorImage)
            End Try
         Next
      End Sub
   End Class

End Namespace