﻿Imports System.Collections.Generic

Namespace System.Reflection
   Public Class PropertyPathResolver

      Protected _PropertyPath As String = ""
      Private _PathProperties As PropertyInfo() = Nothing

      Public Property PropertyPath() As String
         Get
            Return _PropertyPath
         End Get
         Set(value As String)
            If _PropertyPath = value Then Return
            _PropertyPath = value
            _PathProperties = Nothing
         End Set
      End Property
      Public Function GetValueFrom(itm As Object) As Object
         If _PathProperties.Null() Then
            If itm Is Nothing OrElse _PropertyPath = "" Then Return Nothing
            Dim pinfPath = New List(Of PropertyInfo)(5)
            Dim segments = PropertyPath.Split("."c)
            For Each s In segments
               If s.Length = 0 Then Throw Me.Exception("PropertyPath not valid!")
               Dim pinf = itm.GetType().GetProperty(s)

               If pinf.Null Then Throw Me.Exception("PropertyPath not valid!", itm.GetType.Name)

               'If pinf.Null Then Return Nothing

               itm = pinf.GetValue(itm, Nothing)
               pinfPath.Add(pinf)
            Next
            _PathProperties = pinfPath.ToArray()
         Else
            For Each pinf In _PathProperties
               itm = pinf.GetValue(itm, Nothing)
            Next
         End If
         Return itm
      End Function
   End Class
End Namespace
