﻿#Region "FileHeader"
#If False Then ' -------------- FileDescription --------------
ContextMenu-Behavior for TreeviewItem ListboxItem, for set the Item as selected on ContextMenu_Opened 
#End If
' -------------- Imports & Options --------------------
Imports System.Windows.Media
Imports System.ComponentModel, System.Runtime.CompilerServices
Imports TSelf = System.Windows.Controls.SelectOnOpen
#End Region 'FileHeader

Namespace System.Windows.Controls

   Public Class SelectOnOpen

      Private WithEvents _Contextmenu As ContextMenu

      Public Shared Function GetAttachedValue( obj As DependencyObject) As Boolean
         Return DirectCast(obj.GetValue(AttachedValueProperty), Boolean)
      End Function
      Public Shared Sub SetAttachedValue( obj As DependencyObject,  value As Boolean)
         obj.SetValue(AttachedValueProperty, value)
      End Sub
      Public Shared ReadOnly AttachedValueProperty As DependencyProperty = DependencyProperty.RegisterAttached("AttachedValue", GetType(Boolean), GetType(TSelf), New UIPropertyMetadata(AddressOf AttachCallback))
      Private Shared Sub AttachCallback( sender As DependencyObject,  e As DependencyPropertyChangedEventArgs)
         Call (New TSelf()).OnAttached(sender)
      End Sub

      Protected Sub OnAttached(attachTarget As DependencyObject)
         _Contextmenu.TryBe(attachTarget)
      End Sub

      Private Sub _Contextmenu_Opened(sender As Object, e As RoutedEventArgs) Handles _Contextmenu.Opened
         Dim itm As DependencyObject = _Contextmenu.PlacementTarget
         Dim lbi As ListBoxItem = Nothing, tvi As TreeViewItem = Nothing
         While itm.NotNull
            itm = VisualTreeHelper.GetParent(itm)
            If lbi.TryBe(itm) Then
               lbi.IsSelected = True
            ElseIf tvi.TryBe(itm) Then
               tvi.IsSelected = True
            Else
               Continue While
            End If
            Return
         End While
      End Sub
   End Class
End Namespace
