﻿Imports System.Windows.Markup
Imports System.Xaml

Namespace System.Windows.Controls

   Public Class MultiplyExtension : Inherits MarkupExtension : Implements IValueConverter

      Private _Factor As Double
      Public Sub New(Factor As Double)
         _Factor = Factor
      End Sub

      Public Overrides Function ProvideValue(serviceProvider As IServiceProvider) As Object
         Return Me
      End Function

      Public Function Convert(value As Object, targetType As Type, parameter As Object, culture As Globalization.CultureInfo) As Object Implements Data.IValueConverter.Convert
         If TypeOf value Is Double Then Return CType(value, Double) * _Factor
         Return value
      End Function

      Public Function ConvertBack(value As Object, targetType As Type, parameter As Object, culture As Globalization.CultureInfo) As Object Implements Data.IValueConverter.ConvertBack
         If TypeOf value Is Double Then Return CType(value, Double) / _Factor
         Return value
      End Function
   End Class

End Namespace